/**
 * Copyright 2010 Västra Götalandsregionen
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of version 2.1 of the GNU Lesser General Public
 *   License as published by the Free Software Foundation.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 *   Boston, MA 02111-1307  USA
 */

package se.vgregion.liferay.expando;

import com.liferay.portal.model.User;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * Created by IntelliJ IDEA.
 * Created: 2011-11-19 15:14
 *
 * @author <a href="mailto:david.rosell@redpill-linpro.com">David Rosell</a>
 */
public class UserExpandoHelperImpl implements UserExpandoHelper {

    @Autowired
    private ExpandoUtil expandoUtil;

    @Override
    public <T> void set(String columnName, T value, long companyId, long userId) {
        expandoUtil.setExpando(USER_CLASSNAME, columnName, value, companyId, userId, ExpandoUtil.Mode.AUTO_CREATE);
    }

    @Override
    public <T> void set(String columnName, T value, User user) {
        set(columnName, value, user.getCompanyId(), user.getUserId());
    }

    @Override
    public <T> T get(String columnName, long companyId, long userId) {
        try {
            return (T) expandoUtil.getExpando(companyId, USER_CLASSNAME, columnName, userId);
        } catch (Exception ex) {
            return null;
        }
    }

    @Override
    public <T> T get(String columnName, User user) {
        try {
            return get(columnName, user.getCompanyId(), user.getUserId());
        } catch (Exception ex) {
            return null;
        }
    }

    public ExpandoUtil getExpandoUtil() {
        return expandoUtil;
    }

    public void setExpandoUtil(ExpandoUtil expandoUtil) {
        this.expandoUtil = expandoUtil;
    }

    private static final String USER_CLASSNAME = User.class.getName();
}
